# definice vlastnich tagu pro templates

import os

import nbconvert
from django import template
from django.utils.safestring import mark_safe
from traitlets.config import Config

register = template.Library()


@register.filter
def jupyterize(value):
    """ Exportuje jupyterovsky notebook do raw HTML s vyuzitim vlastnich templates.
        Vynechava tagy
    """

    # lokalni soubor
    filename = os.path.join(value.value.file.storage.location, value.value.file.name)

    # konvertuj do HTML s pouzitim vlastni template
    c = Config()

    c.TagRemovePreprocessor.enabled = True  # Nutne
    c.TagRemovePreprocessor.remove_cell_tags = ["exclude"]
    c.TagRemovePreprocessor.remove_input_tags = ["output"]
    c.TemplateExporter.exclude_output_prompt = (
        True  # potlaci prazdne vystupy typu "Out[8]"
    )
    c.preprocessors = ["TagRemovePreprocessor"]

    nb_body, _ = nbconvert.TemplateExporter(
        config=c, template_file="uniweb/templates/jupyter/my.tpl"
    ).from_filename(filename)

    # HACK: fucking ugly. Ale netusim kde se to tam bere, asi nekde v hloubi notebookovskych templates
    if nb_body.startswith("None"):
        nb_body = nb_body[4:]

    return mark_safe(nb_body)
